//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  DeepSkyBlue
#property indicator_color2  Red
#property indicator_color3  Yellow
#property indicator_width1  2
#property indicator_level1  0
#import "LibSSA.dll"
   void fastSingular(double& sourceArray[],int arraySize, int lag, int numberOfComputationLoops, double& destinationArray[]);
#import

//
//
//
//
//

extern int    Length                   = 14;
extern int    Price                    = PRICE_CLOSE;
extern int    MaLength                 = 8;
extern int    MaType                   = MODE_EMA;
extern int    SSABars                  = 300;
extern int    SSANumComputations       = 2;
extern int    SSALag                   = 10;
extern int    SSANormalizationPeriod   = 10;
extern bool   Invert                   = false;

extern string _                        = "Alerts Settings";
extern bool   alertsOn                 = true;
extern bool   alertsOnRsxMaCross       = true;
extern bool   alertsOnSsaMaCross       = false;
extern bool   alertsOnSsaRsxCross      = false; 
extern bool   alertsOnCurrent          = false;
extern bool   alertsMessage            = true;
extern bool   alertsSound              = true;
extern bool   alertsEmail              = false;

extern bool   arrowsVisible            = true;
extern string arrowsIdentifier         = "rsxmassaArrows";
extern double arrowsDisplacement       = 1.0;
extern bool   arrowsOnRsxMaCross       = true;
extern color  arrowsRsxMaCrossUpColor  = DeepSkyBlue;
extern color  arrowsRsxMaCrossDnColor  = Red;
extern bool   arrowsOnSsaMaCross       = false;
extern color  arrowsSsaMaCrossUpColor  = DeepSkyBlue;
extern color  arrowsSsaMaCrossDnColor  = Red;
extern bool   arrowsOnSsaRsxCross      = false; 
extern color  arrowsSsaRsxCrossUpColor = DeepSkyBlue;
extern color  arrowsSsaRsxCrossDnColor = Red;

//
//
//
//
//

double rsx[];
double ma[];
double ssa[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorDigits(5);
   SetIndexBuffer(0,rsx); SetIndexLabel(0,"RSX");
   SetIndexBuffer(1,ma);  SetIndexLabel(1,"MA");
   SetIndexBuffer(2,ssa); SetIndexLabel(2,"SSA");
   IndicatorShortName("Rsx + ma + fullSSA ("+Length+","+MaLength+","+SSALag+","+SSANumComputations+","+SSANormalizationPeriod+")");
   return(0);
}

//
//
//
//
//

int deinit()
{

  if (arrowsVisible) deleteArrows();  
    
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double wrkBuffer[][16];
double ssaIn[];
double ssaOut[];

double trends[][3];

#define _rma1 0
#define _sma1 1
#define _rsa1 2


int start()
{
   double multiplier=1;
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         int n     = MathMin(Bars-1,SSABars);
         if (ArrayRange(wrkBuffer,0) != Bars) ArrayResize(wrkBuffer,Bars);
         
         if (ArraySize(ssaIn)!=n)
         {
            ArrayResize(ssaIn,n);
            ArrayResize(ssaOut,n);
         }
         if (Invert) multiplier=-1;

   //
   //
   //
   //
   //
   
   double Kg = (3.0)/(2.0+Length); 
   double Hg = 1.0-Kg;
   if (ArrayRange(trends,0)!=Bars) {  ArrayResize(trends,Bars); }
   for(i=limit, r=Bars-i-1; i>=0; i--, r++)
   {
      wrkBuffer[r][12] = iMA(NULL,0,1,0,MODE_SMA,Price,i);

         if (i==(Bars-1)) { for (int c=0; c<12; c++) wrkBuffer[r][c] = 0; continue; }  

      //
      //
      //
      //
      //
      
      double mom = wrkBuffer[r][12]-wrkBuffer[r-1][12];
      double moa = MathAbs(mom);
      for (int k=0; k<3; k++)
      {
         int kk = k*2;
            wrkBuffer[r][kk+0] = Kg*mom                + Hg*wrkBuffer[r-1][kk+0];
            wrkBuffer[r][kk+1] = Kg*wrkBuffer[r][kk+0] + Hg*wrkBuffer[r-1][kk+1]; mom = 1.5*wrkBuffer[r][kk+0] - 0.5 * wrkBuffer[r][kk+1];
            wrkBuffer[r][kk+6] = Kg*moa                + Hg*wrkBuffer[r-1][kk+6];
            wrkBuffer[r][kk+7] = Kg*wrkBuffer[r][kk+6] + Hg*wrkBuffer[r-1][kk+7]; moa = 1.5*wrkBuffer[r][kk+6] - 0.5 * wrkBuffer[r][kk+7];
      }
      if (moa != 0)
           rsx[i] = multiplier*mom/moa; 
      else rsx[i] = 0;
      
      
      //
      //
      //
      //
      //
      
      wrkBuffer[r][13] = iMA(NULL,0,SSANormalizationPeriod,0,MODE_SMA,Price,i);
      wrkBuffer[r][14] = iStdDev(NULL,0,SSANormalizationPeriod,0,MODE_SMA,Price,i)*3.0;
      wrkBuffer[r][15] = multiplier*(wrkBuffer[r][12]-wrkBuffer[r][13])/MathMax(wrkBuffer[r][14],0.000000000001);
   }
   
   for (i=n-1, r=Bars-i-1; i>=0; i--,r++) ssaIn[i] = wrkBuffer[r][15];
      fastSingular(ssaIn,n,SSALag,SSANumComputations,ssaOut);
            ArrayCopy(ssa,ssaOut);
            SetIndexDrawBegin(0,Bars-n-1);
            SetIndexDrawBegin(1,Bars-n-1);
            SetIndexDrawBegin(2,Bars-n-1);
            
   for (i=limit, r=Bars-i-1; i>=0; i--, r++)
   {
       ma[i] = iMAOnArray(rsx,0,MaLength,0,MaType,i);
       setTrends(i,r);
       manageArrow(i,r);
   }
  
   //
   //
   //
   //
   //
   
   manageAlerts();
   return(0);
}

//
//
//
//
//

void setTrends(int i, int r)
{
   trends[r][_rma1] = trends[r-1][_rma1];
   trends[r][_sma1] = trends[r-1][_sma1];
   trends[r][_rsa1] = trends[r-1][_rsa1];
   
      if (rsx[i] > ma[i])  trends[r][_rma1] =  1;
      if (rsx[i] < ma[i])  trends[r][_rma1] = -1;
      if (ssa[i] > ma[i])  trends[r][_sma1] =  1;
      if (ssa[i] < ma[i])  trends[r][_sma1] = -1;
      if (ssa[i] > rsx[i]) trends[r][_rsa1] =  1;
      if (ssa[i] < rsx[i]) trends[r][_rsa1] = -1;
           
}

//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;

      //
      //
      //
      //
      //
            
      static datetime time1 = 0;
      static string   mess1 = "";
      if (alertsOnRsxMaCross && trends[whichBar][_rma1] != trends[whichBar-1][_rma1])
      {
         if (trends[whichBar][_rma1] ==  1) doAlert(time1,mess1,whichBar,"Rsx crossing Ma up");
         if (trends[whichBar][_rma1] == -1) doAlert(time1,mess1,whichBar,"Rsx crossing Ma down");
      }
      static datetime time2 = 0;
      static string   mess2 = "";
      if (alertsOnSsaMaCross && trends[whichBar][_sma1] != trends[whichBar-1][_sma1])
      {
         if (trends[whichBar][_sma1] ==  1) doAlert(time2,mess2,whichBar,"Ssa crossing Ma up");
         if (trends[whichBar][_sma1] == -1) doAlert(time2,mess2,whichBar,"Ssa crossing Ma down");
      }
      static datetime time3 = 0;
      static string   mess3 = "";
      if (alertsOnSsaRsxCross && trends[whichBar][_rsa1] != trends[whichBar-1][_rsa1])
      {
         if (trends[whichBar][_rsa1] ==  1) doAlert(time3,mess3,whichBar,"Ssa crossing Ma up");
         if (trends[whichBar][_rsa1] == -1) doAlert(time3,mess3,whichBar,"Ssa crossing Ma down");
      }
      
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," rsx + ma + fullSSA ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," rsx + ma + fullSSA "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i, int r)
{
   if (arrowsVisible)
   {
      deleteArrow(Time[i]);
      if (arrowsOnRsxMaCross && trends[r][_rma1]!=trends[r-1][_rma1])
      {
         if (trends[r][_rma1] == 1)  drawArrow(i,arrowsRsxMaCrossUpColor,241,false);
         if (trends[r][_rma1] ==-1)  drawArrow(i,arrowsRsxMaCrossDnColor,242,true);
      }
      if (arrowsOnSsaMaCross && trends[r][_sma1]!=trends[r-1][_sma1])
      {
         if (trends[r][_sma1] == 1) drawArrow(i,arrowsSsaMaCrossUpColor,241,false);
         if (trends[r][_sma1] ==-1) drawArrow(i,arrowsSsaMaCrossDnColor,242,true);
      }
      if (arrowsOnSsaRsxCross && trends[r][_rsa1]!=trends[r-1][_rsa1])
      {
         if (trends[r][_rsa1] == 1) drawArrow(i,arrowsSsaRsxCrossUpColor,241,false);
         if (trends[r][_rsa1] ==-1) drawArrow(i,arrowsSsaRsxCrossDnColor,242,true);
      }
      
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
      string name = arrowsIdentifier+":"+Time[i];
      double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsDisplacement * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsDisplacement * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}